# Download and run the deskop applications

The macOS and Windows desktop applications are meant to work out of the box. If there are any issues, please email Robert Cudmore (rhcudmore@ucdavis.edu) and we will fix it.

Downloading and running SanPy is designed to be very simple. You download a file (links below), unzip the download (macOS), and double-click to run. There is no installer, just a downloaded file you can double-click.

## Mac download

If you have an older Mac with an Intel/x86 chip then download the **`x86`** version. If you have a newer Mac with an M1/M2/M3 chip then download the **`arm`** version.

If your not sure which type of Mac you have, then download the **`x86`** version.

[Download macOS x86 zip](https://github.com/cudmore/SanPy/releases/download/v0.2.3/SanPy-macOS-x86.zip){ .md-button .md-button--primary}
[Download macOS arm zip](https://github.com/cudmore/SanPy/releases/download/v0.2.3/SanPy-macOS-arm.zip){ .md-button .md-button--primary}

### Mac download and run recipe

 - Download the `zip` file
 - Once downloaded, double-click on `SanPy.zip` to uncompress it to `SanPy.app`
 - **Important:** Move the `SanPy.app` to your `Applications` folder
 - Double-click on `SanPy.app` (in your Applications folder) to run SanPy
 
**Troubleshooting:** If you run into security issues, please see [Security on macOS](#security-on-macos).

## Windows download

[Download Windows exe](https://github.com/cudmore/SanPy/releases/download/v0.2.3/SanPy.exe
){ .md-button .md-button--primary}

### Windows download and run recipe

 - Download the `exe` file
 - Once downloaded, double-click on `SanPy.exe` to run SanPy

**Troubleshooting:** If you run into security issues, please see [Security on Windows](#security-on-windows).

<!--
## Current Version
 - Version 0.1.25, Released on May 12, 2023
-->

## Current and previous releases (on GitHub)

You can always download all previous versions of SanPy from our GitHub repository.

[Go To Current Release](https://github.com/cudmore/SanPy/releases){ .md-button .md-button--primary }

## Troubleshooting

Here are some common ways to troubleshoot the running of the SanPy GUI on macOS and Windows.

### Security on macOS

If SanPy does not run, the simplest solution is to do the following:

 - Put the `SanPy.app` into your `Applications` folder.
 - Right click `SanPy.app` and select the `Open` menu. Or, use `command+click` and select the `Open` menu.

 The first time you run SanPy it might take 10-30 seconds to show the GUI. After that, it will open again pretty quick.

### Security on Windows

Same story as on macOS. Work your way through the warnings and it will run on Windows.

On Windows 11, each time you run SanPy, it takes between 10-30 seconds to bring up the GUI. We are working on fixing this.